#!/usr/bin/env python
'''Display reservations'''
__revision__ = '$Revision: 1.4 $'

from sss.ssslib import comm_lib
from sys import argv
from elementtree.ElementTree import XML
from time import localtime, strftime
from Cobalt.Util import print_tabular

if __name__ == '__main__':
    comm = comm_lib(debug='-d' in argv)
    handle = comm.ClientInit('scheduler')
    comm.SendMessage(handle,
                     '''<GetPartition><Partition name="*"><Reservation name="*" start="*"''' +
                     ''' duration="*" user="*"/></Partition></GetPartition>''')
    r = comm.RecvMessage(handle)
    reservations = {}
    for partition in XML(r).findall('.//Partition'):
        for reservation in partition.findall('Reservation'):
            if reservations.has_key(reservation.get('name')):
                reservations[reservation.get('name')][1].append(partition.get('name'))
            else:
                reservations[reservation.get('name')] = (reservation, [partition.get('name')])

    output = [('Reservation', 'User', 'Start', 'Duration', 'Partitions')]
    for reservation in reservations:
        output.append((reservation, reservations[reservation][0].get('user', ''),
                   strftime("%c",localtime(float(reservations[reservation][0].get('start')))).replace(' ', '_'),
                   reservations[reservation][0].get('duration'), str(reservations[reservation][1])))
    print_tabular(output)
                     
